package cost.speed;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

public class Sort {

	static final int I_MAX = 10;
	// static final int I_MAX = 1;
	// static final int I_MAX = 2;
	// static final int I_MAX = 3;
	// static final int I_MAX = 4;
	// static final int I_MAX = 10;
	static final int J_MAX = 3;

	static final int COUNT = 100 * 10000;
	static final int DIV = (I_MAX == 3) ? 10 : I_MAX * 5;

	// static final int DIV = 1;

	public static void main(String[] args) {
		List data = createData();
		// List data = createDataSorted();
		// List data = createDataReverse();

		System.out.println("f[^F" + data.size());
		System.gc();
		try {
			Thread.sleep(100);
		} catch (InterruptedException e) {
		}

		double sum = 0;
		for (int i = 0; i < 10; i++) {
			// sum += sort(data);
			sum += tree(data);
		}
		System.out.println(sum / 10);
	}

	static List createData() {
		List data = new ArrayList(I_MAX * J_MAX);

		StringBuffer sb = new StringBuffer("A000");
		for (int i = 0; i < I_MAX; i++) {
			sb.setCharAt(0, (char) ('A' + i));
			for (int j = J_MAX - 1; j >= 0; j--) {
				sb.setCharAt(1, (char) ('0' + (j / 100) % 10));
				sb.setCharAt(2, (char) ('0' + (j / 10) % 10));
				sb.setCharAt(3, (char) ('0' + (j / 1) % 10));
				String key = sb.toString();
				data.add(key);
			}
		}

		return data;
	}

	static List createDataSorted() {
		List data = new ArrayList(I_MAX * J_MAX);

		StringBuffer sb = new StringBuffer("A000");
		for (int i = 0; i < I_MAX * J_MAX; i++) {
			sb.setCharAt(1, (char) ('0' + (i / 100) % 10));
			sb.setCharAt(2, (char) ('0' + (i / 10) % 10));
			sb.setCharAt(3, (char) ('0' + (i / 1) % 10));
			String key = sb.toString();
			data.add(key);
		}

		return data;
	}

	static List createDataReverse() {
		List data = new ArrayList(I_MAX * J_MAX);

		StringBuffer sb = new StringBuffer("A000");
		for (int i = I_MAX * J_MAX - 1; i >= 0; i--) {
			sb.setCharAt(1, (char) ('0' + (i / 100) % 10));
			sb.setCharAt(2, (char) ('0' + (i / 10) % 10));
			sb.setCharAt(3, (char) ('0' + (i / 1) % 10));
			String key = sb.toString();
			data.add(key);
		}

		return data;
	}

	static double sort(List data) {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT / DIV; i++) {
			// f[^
			List list;
			if (true) {
				int size = data.size();
				list = new ArrayList(size);
				for (int j = 0; j < size; j++) {
					list.add(data.get(j));
				}
			} else {
				list = new ArrayList(data); // toArray()gĂ̂ő
			}
			// \[g
			Collections.sort(list);
			// f[^
			if (true) {
				int size = list.size();
				for (int j = 0; j < size; j++) {
					Object obj = list.get(j);
					// System.out.println(obj);
				}
			} else {
				for (Iterator j = list.iterator(); j.hasNext();) {
					Object obj = j.next();
					// System.out.println(obj);
				}
			}
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("sort:" + e * DIV);
		return e * DIV;
	}

	static double tree(List data) {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT / DIV; i++) {
			// f[^
			Set list;
			if (true) {
				int size = data.size();
				list = new TreeSet();
				for (int j = 0; j < size; j++) {
					list.add(data.get(j));
				}
			} else {
				list = new TreeSet(data); // Iteratorp^[gׁAx
			}
			// f[^
			for (Iterator j = list.iterator(); j.hasNext();) {
				Object obj = j.next();
				// System.out.println(obj);
			}
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("tree:" + e * DIV);
		return e * DIV;
	}
}
